-- Copyright (c) 2016-2019 Cloudera, Inc. All rights reserved.
-- This code is provided to you pursuant to your written agreement with Cloudera, which may be the terms of the
-- Affero General Public License version 3 (AGPLv3), or pursuant to a written agreement with a third party authorized
-- to distribute this code.  If you do not have a written agreement with Cloudera or with an authorized and
-- properly licensed third party, you do not have any rights to this code.
-- If this code is provided to you under the terms of the AGPLv3:
-- (A) CLOUDERA PROVIDES THIS CODE TO YOU WITHOUT WARRANTIES OF ANY KIND;
-- (B) CLOUDERA DISCLAIMS ANY AND ALL EXPRESS AND IMPLIED WARRANTIES WITH RESPECT TO THIS CODE, INCLUDING BUT NOT
-- LIMITED TO IMPLIED WARRANTIES OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE;
-- (C) CLOUDERA IS NOT LIABLE TO YOU, AND WILL NOT DEFEND, INDEMNIFY, OR HOLD YOU HARMLESS FOR ANY CLAIMS ARISING
-- FROM OR RELATED TO THE CODE; AND
-- (D) WITH RESPECT TO YOUR EXERCISE OF ANY RIGHTS GRANTED TO YOU FOR THE CODE, CLOUDERA IS NOT LIABLE FOR ANY
-- DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, PUNITIVE OR CONSEQUENTIAL DAMAGES INCLUDING, BUT NOT LIMITED
-- TO, DAMAGES RELATED TO LOST REVENUE, LOST PROFITS, LOSS OF INCOME, LOSS OF BUSINESS ADVANTAGE OR
-- UNAVAILABILITY, OR LOSS OR CORRUPTION OF DATA.



CREATE TABLE alert_policy (
  `id`                        BIGINT        AUTO_INCREMENT  NOT NULL,
  `name`                      VARCHAR(255)                  NOT NULL,
  `description`               TEXT,
  `enabled`                   BOOLEAN                       NOT NULL,
  `version`                   INT                           NOT NULL,
  `policy`                    TEXT                          NOT NULL,
  `executionIntervalInMillis` BIGINT                        NOT NULL,
  `executionDelayInMillis`    BIGINT                        NOT NULL,
  `timestamp`                 BIGINT,
  PRIMARY KEY (`id`),
  UNIQUE KEY `uk_alerts__name` (`name`)
);

CREATE TABLE notifier (
  `id`                  BIGINT        AUTO_INCREMENT  NOT NULL,
  `notifierProviderId`  VARCHAR(255)                  NOT NULL,
  `name`                VARCHAR(255)                  NOT NULL,
  `description`         VARCHAR(255),
  `config`              TEXT                          NOT NULL,
  `rateLimitCount`      INT,
  `rateLimitTimeUnit`   TINYINT,
  `timestamp`           BIGINT,
  PRIMARY KEY (`id`),
  UNIQUE KEY `uk_notifier__name` (`name`)
);

CREATE TABLE alert_policy_notifier_mapping (
  `alertPolicyId`            BIGINT     NOT NULL,
  `notifierId`         BIGINT     NOT NULL,

  UNIQUE KEY `uk_alerts_notifier_mapping` (`alertPolicyId`, `notifierId`),
  FOREIGN KEY (`alertPolicyId`) REFERENCES alert_policy (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  FOREIGN KEY (`notifierId`) REFERENCES notifier (`id`) ON DELETE CASCADE ON UPDATE CASCADE
);

CREATE TABLE user_notification_status (
  `userName`        VARCHAR(255)    NOT NULL,
  `topicPartition`  INT             NOT NULL,
  `offset`          BIGINT          NOT NULL,

  UNIQUE KEY `uk_user_notification_status` (`userName`, `topicPartition`, `offset`)
)