-- Copyright (c) 2016-2019 Cloudera, Inc. All rights reserved.
-- This code is provided to you pursuant to your written agreement with Cloudera, which may be the terms of the
-- Affero General Public License version 3 (AGPLv3), or pursuant to a written agreement with a third party authorized
-- to distribute this code.  If you do not have a written agreement with Cloudera or with an authorized and
-- properly licensed third party, you do not have any rights to this code.
-- If this code is provided to you under the terms of the AGPLv3:
-- (A) CLOUDERA PROVIDES THIS CODE TO YOU WITHOUT WARRANTIES OF ANY KIND;
-- (B) CLOUDERA DISCLAIMS ANY AND ALL EXPRESS AND IMPLIED WARRANTIES WITH RESPECT TO THIS CODE, INCLUDING BUT NOT
-- LIMITED TO IMPLIED WARRANTIES OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE;
-- (C) CLOUDERA IS NOT LIABLE TO YOU, AND WILL NOT DEFEND, INDEMNIFY, OR HOLD YOU HARMLESS FOR ANY CLAIMS ARISING
-- FROM OR RELATED TO THE CODE; AND
-- (D) WITH RESPECT TO YOUR EXERCISE OF ANY RIGHTS GRANTED TO YOU FOR THE CODE, CLOUDERA IS NOT LIABLE FOR ANY
-- DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, PUNITIVE OR CONSEQUENTIAL DAMAGES INCLUDING, BUT NOT LIMITED
-- TO, DAMAGES RELATED TO LOST REVENUE, LOST PROFITS, LOSS OF INCOME, LOSS OF BUSINESS ADVANTAGE OR
-- UNAVAILABILITY, OR LOSS OR CORRUPTION OF DATA.


CREATE TABLE "alert_policy" (
  "id"                        NUMBER(19,0)        NOT NULL,
  "name"                      VARCHAR2(255)       NOT NULL,
  "description"               VARCHAR2(4000),
  "enabled"                   NUMBER(1)           NOT NULL,
  "version"                   NUMBER(10,0)        NOT NULL,
  "policy"                    VARCHAR2(4000),
  "executionIntervalInMillis" NUMBER(19,0)        NOT NULL,
  "executionDelayInMillis"    NUMBER(19,0)        NOT NULL,
  "timestamp"                 NUMBER(19,0),
  CONSTRAINT pk_alert_policy__id PRIMARY KEY ("id"),
  CONSTRAINT uk_alert_policy__name UNIQUE ("name")
) SEGMENT CREATION IMMEDIATE;

CREATE SEQUENCE "ALERT_POLICY" START WITH 1 INCREMENT BY 1 MAXVALUE 10000000000000000000;

CREATE TABLE "notifier" (
  "id"                  NUMBER(19,0)    NOT NULL,
  "notifierProviderId"  VARCHAR(255)    NOT NULL,
  "name"                VARCHAR(255)    NOT NULL,
  "description"         VARCHAR(255),
  "config"              VARCHAR2(4000)  NOT NULL,
  "rateLimitCount"      NUMBER(10,0),
  "rateLimitTimeUnit"   NUMBER(3,0),
  "timestamp"           NUMBER(19,0),
  CONSTRAINT pk_notifier PRIMARY KEY ("id"),
  CONSTRAINT uk_notifier__name UNIQUE ("name")
) SEGMENT CREATION IMMEDIATE;

CREATE SEQUENCE "NOTIFIER" START WITH 1 INCREMENT BY 1 MAXVALUE 10000000000000000000;

CREATE TABLE "alert_policy_notifier_mapping" (
  "alertPolicyId"      NUMBER(19,0)     NOT NULL,
  "notifierId"         NUMBER(19,0)     NOT NULL,
  CONSTRAINT uk_apnm UNIQUE ("alertPolicyId", "notifierId"),
  CONSTRAINT fk_apnm__alertId FOREIGN KEY ("alertPolicyId") REFERENCES "alert_policy" ("id") ON DELETE CASCADE,
  CONSTRAINT fk_apnm__notifierId FOREIGN KEY ("notifierId") REFERENCES "notifier" ("id") ON DELETE CASCADE
) SEGMENT CREATION IMMEDIATE;

CREATE TABLE "user_notification_status" (
  "userName"        VARCHAR(255)    NOT NULL,
  "topicPartition"  NUMBER(10,0)    NOT NULL,
  "offset"          NUMBER(19,0)    NOT NULL,
  CONSTRAINT uk_user_notification_status UNIQUE ("userName", "topicPartition", "offset")
)